function inserted(el, binding) {
  var callback = binding.value;
  var debounce = binding.arg || 200;
  var options = binding.options || { passive: true };

  var debounceTimeout = null;
  var onResize = function onResize() {
    clearTimeout(debounceTimeout);
    debounceTimeout = setTimeout(callback, debounce, options);
  };

  window.addEventListener('resize', onResize, options);
  el._onResize = {
    callback: callback,
    options: options
  };

  if (!binding.modifiers || !binding.modifiers.quiet) {
    onResize();
  }
}

function unbind(el, binding) {
  var _el$_onResize = el._onResize,
      callback = _el$_onResize.callback,
      options = _el$_onResize.options;


  window.removeEventListener('resize', callback, options);
  delete el._onResize;
}

export default {
  name: 'resize',
  inserted: inserted,
  unbind: unbind
};